@ECHO off
SET ver=ghostly v20180106

REM iRacing-processname
SET iRpn=iRacingSim64DX11.exe
ECHO iRpn==%iRpn%

REM path to iRacing-directory in MyDocuments
SET iRro="%UserProfile%\Documents\iRacing"
ECHO iRro==%iRro%

REM iRacing can not be running
TASKLIST /FI "IMAGENAME eq %iRpn%" 2>NUL | FIND /I /N "%iRpn%" >NUL
IF %ERRORLEVEL% EQU 0 (
	ECHO please close iRacing first ...
	GOTO abort
)

REM backup-directory
SET ts=%DATE%-%TIME:~0,8%
SET ts=%ts: =0%
SET ts=%ts:/=%
SET ts=%ts:-=%
SET ts=%ts:.=%
SET ts=%ts::=%
SET bkp=lapfiles_%ts%
ECHO bkp==%bkp%

REM backup-directory can not exist
IF EXIST "%iRro%\%bkp%" GOTO abort

REM move lapfiles to bkp
MOVE "%iRro%\lapfiles" "%iRro%\%bkp%"
IF %ERRORLEVEL% NEQ 0 (
	ECHO.
	ECHO lapfiles backup failed
	GOTO abort
)

ECHO.
ECHO %ver% is ready for lapfiles
ECHO please start iRacing, drive your laps
ECHO and after that, close iRacing and ...
ECHO.
PAUSE

:loop
TASKLIST /FI "IMAGENAME eq %iRpn%" 2>NUL | FIND /I /N "%iRpn%" >NUL
IF %ERRORLEVEL% EQU 0 (
	ECHO please close iRacing first ...
	PAUSE
	GOTO loop
)
ECHO.

REM find olap and blap
SET olap=
SET blap=
FOR /F "delims=" %%A IN ('DIR /B /S "%iRro%\lapfiles\*.olap"') DO SET "olap=%%A"
FOR /F "delims=" %%A IN ('DIR /B /S "%iRro%\lapfiles\*.blap"') DO SET "blap=%%A"
ECHO olap==%olap%
ECHO blap==%blap%

SET tv=%olap:*lapfiles\=%

REM track
SET track=
FOR /F "delims=\ tokens=1" %%A IN ('ECHO %tv%') DO SET track=%%A
SET track=%track: =%
ECHO track==%track%

REM uid and car
SET car=
SET uid=
FOR /F "delims=\ tokens=2" %%A IN ('ECHO %tv%') DO SET car=%%A
FOR /F "delims=_ tokens=1" %%A IN ('ECHO %car%') DO SET uid=%%A
ECHO uid==%uid%
FOR /F "delims=_ tokens=2" %%A IN ('ECHO %car%') DO SET car=%%A
SET car=%car:*_=%
SET car=%car:~0,-5%
ECHO car==%car%

REM setup
SET setup=
SETLOCAL ENABLEDELAYEDEXPANSION 
FOR /F "delims=" %%A IN ('DIR /S /B "%iRro%\setups\-Current-"') DO (
	SET tv=%%A
	SET tv=!tv: =!
	ECHO !tv! | FIND "%car%" >NUL
	IF NOT ERRORLEVEL 1 SET setup=%%A
)
SETLOCAL DISABLEDELAYEDEXPANSION
ECHO setup==%setup%

REM copy files into bkp
COPY "%olap%" "%iRro%\%bkp%\%uid%_%track%_%car%.olap"
COPY "%blap%" "%iRro%\%bkp%\%uid%_%track%_%car%.blap"
COPY "%setup%" "%iRro%\%bkp%\%uid%_%track%_%car%.sto"

REM remove new created lapfile-directory
RMDIR /S /Q "%iRro%\lapfiles"

REM restore bkp
XCOPY /I /S /E /Q "%iRro%\%bkp%" "%iRro%\lapfiles"

ECHO.
ECHO o/blap and sto are saved in "%iRro%\lapfiles"
ECHO (btw. backup of lapfiles stays in %bkp%)
ECHO.

GOTO end

:abort
ECHO abort.
GOTO endend

:end
ECHO end.
GOTO endend

:endend
ECHO.
PAUSE
